<?php

class WorkflowvalueModel {
  public $item_id;
  public $object_id;
  public $value_string;
  public $value_int;
  public $value_text;
  public $changed_by;
  public $changed;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new Workflowvalue();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();
    
    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Workflowvalue", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Workflowvalue($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Workflowvalue", "*");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Workflowvalue($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Workflowvalue", "*", "$where");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Workflowvalue($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  

  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Workflowvalue", "*", $where);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Workflowvalue($data);
      }
    }
    
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    //var_dump($filter);exit;
    
    if(array_key_exists("create_by", $filter)) {
      $create_by = $filter['create_by'];
      if(is_numeric($create_by)) {
        $where .= " AND create_by=$create_by";
      }
    }
    
    if(array_key_exists("changed_by", $filter)) {
      $changed_by = $filter['changed_by'];
      if(is_numeric($create_by)) {
        $where .= " AND changed_by=$changed_by";
      }
    }
    
    if(array_key_exists("item_id", $filter)) {
      $item_id = $filter['item_id'];
      if(is_numeric($item_id)) {
        $where .= " AND item_id=$item_id";
      }
    }
    
    if(array_key_exists("object_id", $filter)) {
      $object_id = $filter['object_id'];
      if(is_numeric($object_id)) {
        $where .= " AND object_id=$object_id";
      }
    }
    
    
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}